/* -*- c++ -*-
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004-2007 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#ifndef __TK_EXPERIMENTER_H__
#define __TK_EXPERIMENTER_H__

#include <gtkmm.h>

#include "libtkresolver/tkresolver.h"
#include "parameters.h"
#include "location_selector.h"
#include "operator_selector.h"
#include "text_frame.h"
#include "flash_toggle_tool.h"

namespace TkResolver {
  namespace Experimenter {

    
    class Experimenter : public Gtk::Window
      {
      private:
	SDL                   _sdl;
	Db::Database          _database;

	Gtk::Toolbar          _toolbar;
	FlashToggleTool       _control;
	
	Parameters            _parameters;
	LocationSelector      _location;
	OperatorSelector   _operators;
	TextPtr               _notes;
	
        sigc::connection      _timeout;

	bool get_location_id(Db::Id & location_id, bool interactive = true);
	
	void control_toggle();
	bool control_start();
	bool control_notify();
	void control_stop();
	bool control_exec();

	void control_notify_start();
	void control_notify_stop();
	
	void execute_control();
	void execute_proper(bool test,
			    const Db::IdList & operators,
			    bool control,
			    const String * notes = 0,
			    bool interactive = true);
	void execute_or_test(bool test);
      public:
	Experimenter(const String & data_source_name,
		     const String & username,
		     const String & password);
	void execute();
	void test();
      };
    
    
  } /* namespace Experimenter */
}; /* namespace TkResolver */

#endif /* __TK_EXPERIMENTER_H__ */
