/* -*- c++ -*-
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2007 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#ifndef __TK_EXP_SPEED_H__
#define __TK_EXP_SPEED_H__

#include <gtkmm.h>

#include "libtkcommon/tkvalue.h"

namespace TkResolver {
  namespace Experimenter {
    
    class Speed : public Gtk::HBox
      {
      public:
	typedef sigc::signal1<void, bool> ScrollChanged;
	
      private:
	Gtk::Adjustment   _adjustment;
	Gtk::ToggleButton _scroll;
	Gtk::SpinButton   _speed;
	
	ScrollChanged _signal_scroll_changed;
	
	void scroll_toggled();
      public:
	Speed();
	ScrollChanged * signal_scroll_changed();
	bool get_scrolled() const;
	double get_speed() const;
      };
    
  } /* namespace Experimenter */
}; /* namespace TkResolver */

#endif /* __TK_EXP_SPEED_H__ */
