/*
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004 Robert Ham <rah@bash.sh>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdexcept>

#include "maths.h"


unsigned short
TkResolver:: find_next_power_of_two_power(unsigned n)
{
  if (n == 0)
    throw std::invalid_argument("2^n cannot equal 0");
  if (n == 1)
    return 0;

  unsigned pot;
  unsigned short power;

  for (power = 0, pot = 0;
       pot < n;
       pot = 1U << ++power);

  return power;
}

unsigned short
TkResolver:: find_next_power_of_two(unsigned n)
{
  return 1U << find_next_power_of_two_power(n);
}
