/* -*- c++ -*-
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004-2007 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#ifndef __TK_DATABASE_TYPES_H__
#define __TK_DATABASE_TYPES_H__

#include <memory>

#include <odbc++/types.h>
#include <odbc++/resultset.h>

#include "libtkcommon/tkstring.h"
#include "libtkcommon/tkvalue.h"
#include "libtkrandom/random_types.h"
#include "libtkresolver/types.h"
#include "libtkdb/data_set.h"

namespace TkResolver {
  namespace Db {
    
    typedef odbc::Long Id;
    typedef std::list<Id> IdList;
    //typedef ODBCXX_STRING String;
    typedef odbc::Date Date;
    typedef odbc::Timestamp DateTime;
    typedef Value<odbc::Timestamp> DateTimeValue;
    typedef odbc::Types::SQLType Type;
    typedef odbc::Statement Statement;
    typedef std::auto_ptr<Statement> StatementPtr;
    typedef odbc::PreparedStatement PStatement;
    typedef std::auto_ptr<PStatement> PStatementPtr;
    
    typedef std::auto_ptr<DataSet>  DataSetPtr;
    
    //typedef String Name;
    //typedef StringList NameList;
    
    typedef String Code;
    typedef Value<Code> CodeValue;
    typedef std::list<Code> Codes;
    
  }; /* namespace Db */
}; /* namespace TkResolver */

#endif /* __TK_DATABASE_TYPES_H__ */
