/*
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#ifndef __TK_HOTBITS_H__
#define __TK_HOTBITS_H__

#include <curlpp/cURLpp.hpp>

#include "randomness.h"
#include "retriever_registry.h"

namespace TkResolver {

  namespace Random {

    class HotBits : public Retriever
    {
    private:
      static cURLpp::Cleanup _curl;
      
      static size_t write_curl_data(Buffer *buf, char *ptr, size_t size, size_t nmemb);
      
    public:
      HotBits(unsigned chars);
      virtual Buffer * retrieve();
    };
    
    class HotBitsType : public RetrieverType
    {
    public:
      virtual bool is_true_randomness();
      virtual unsigned get_preferred_block_size();
      virtual Retriever * new_retriever(unsigned count);
    };
  };
  
};


#endif /* __TK_HOTBITS_H__ */
